#ifndef CAMERA_DRIVING_PERCEPTION_TWO_GENERAL_WRAPPER_HEADER_H
#define CAMERA_DRIVING_PERCEPTION_TWO_GENERAL_WRAPPER_HEADER_H
#include "sub/SubWrapperHelper.h"
#include "sub/SubDataWrapper.h"
#include "CameraDrivingPerceptionTwo_SubDataWrapper.h"
#include "pub/PubWrapperHelper.h"
#include "pub/PubDataWrapper.h"
#include "CameraDrivingPerceptionTwo_PubDataWrapper.h"
#include "camera_driving_perception_two/executable.h"

using namespace jac::ap::cameradrivingservice::proxy;
using namespace jac::ap::cameradrivingperservice::skeleton;
using namespace jac::ap::canservice::proxy;
using namespace jac::ap::slamservice::proxy;
using namespace jac::ap::vedservice::proxy;

//PubWrappers
GENERATE_PUB_WRAPPER(CamDrvPerceptionTwo2Fusion_Provide, CamDrvPerceptionTwo2Fusion_PubDataWrapper, CameraDrivingPerceptionServiceSkeleton, perception::vector_CameraPerception2Fusion, CameraDrvPerception2FusionEvent);
//SubWrappers
GENERATE_SUB_WRAPPER(CamDrv2CamDrvPerceptionTwo_Required, CamDrv2CamDrvPerceptionTwo_SubDataWrapper, CameraDrivingServiceProxy, perception::Cam2CamPerceptionStruct, CamDrv2CamDrvPerceptionTwoEvent, "16", 10);
GENERATE_SUB_WRAPPER(Slam2DrvPerceptionTwoOdom_Required, Slam2DrvPerceptionTwoOdom_SubDataWrapper, SLAMServiceProxy, dpc::slam_odometry, SLAMOdometryEvent, "8", 10);
GENERATE_SUB_WRAPPER(CAN2DrvPerceptionTwo_Required, CAN2DrvPerceptionTwo_SubDataWrapper, CANServiceProxy, CAN2SWC, CAN2SWCEvent, "3", 10);
GENERATE_SUB_WRAPPER(VED2DrvPerceptionTwo_Required, VED2DrvPerceptionTwo_SubDataWrapper, VEDServiceProxy, dpc::VED4FusionEgoMotion, VED2FusionEgoMotionEvent, "11", 10);

class GeneralWrapper {
public:
    //Provides
    CamDrvPerceptionTwo2Fusion_Provide _CamDrvPerceptionTwo2Fusion_Provide;
    //Requireds
    CamDrv2CamDrvPerceptionTwo_Required _CamDrv2CamDrvPerceptionTwo_Required;
    Slam2DrvPerceptionTwoOdom_Required _Slam2DrvPerceptionTwoOdom_Required;
    CAN2DrvPerceptionTwo_Required _CAN2DrvPerceptionTwo_Required;
    VED2DrvPerceptionTwo_Required _VED2DrvPerceptionTwo_Required;
    
    GeneralWrapper(ara::log::Logger& mainLog);
    ~GeneralWrapper();
    void Start();
};


#endif
